--[[ For normal milling w/o information for skipped "herbs" the macro should be: /run MillButtonSetup() /click MillButton ]]
--[[ For normal milling w/ information for skipped "herbs" the macro should be: /run MillButtonSetup2() /click MillButton ]]

local L = LibStub("AceLocale-3.0"):GetLocale("MillButton")
local mill = CreateFrame("CheckButton","MillButton",UIParent,"SecureActionButtonTemplate")
mill:SetAttribute("type","macro")
local _, _, _, _, _, item_herb = GetAuctionItemSubClasses(6) --Simple way to get ingame localized ItemType "Herb" through Auctionshouseframe translation

--internal DB for ignored herbs
local MillButton_Herbs = {} --Create empty table
MillButton_Herbs.NotMillable = { 
--Classic
	22710, 		--Bloodthistle / Blutdistel
	8153,  		--Wildvine / Wildranke
	13468, 		--Black Lotus / Schwarzer Lotus
--Burning Crusade
	22788, 		--Flame Cap / Flammenkappe
	22794,		--Fel Lotus / Teufelslotus
--Wrath of the Lichking
	36908,		--Frost Lotus / Frostlotus
--Mist of Pandaria
	72238, 		--Golden Lotus / Goldlotus
	97619,		--Torn Green Tea Leaf / Zerfetzte Teepflanze
	97620, 		--Rain Poppy Petal / Regenmohnblte
	97621,		--Silkweed Stem / Seidenkrautstiel
	97622,		--Sbow Lily Petal / Schneelilienblte
	97623, 		--Fool's Cap Spores / Narrenkappensporen
	97624  		--Desecrated Herb Pod / Entweihte Krautkapsel
--Warlords of Draenor / Data from latest Alphapatch 04-23-2014
--[[	109992,		--Blackrock Fragment
	109629,		--Talador Orchid Petal
	109628,		--Nagrand Arrowbloom Petal
	109627,		--Starflower Petal
	109626,		--Gorgrond Flytran Ichor
	109625,		--Broken Fireweed Stem
	109624,		--Broken Frostweed Stem	
	109130		--Chameleon Lotus	]]
}
--internal DB for millable herbs
MillButton_Herbs.Millable = {
	89639 --Desecrated Herb / Entweihtes Kraut
}

--codecleanup testing
--[[
local function findherb()
	for b=0,4 do
		for s=1,GetContainerNumSlots(b) do
			local itemID = GetContainerItemID(b,s)
			local _,count = GetContainerItemInfo(b,s)
			--search internal table for ignored herb ids and skip them
			if extended_millbutton~=true then
				return
			else
				for h=1,#MillButton_Herbs.NotMillable do
					local herb = MillButton_Herbs.NotMillable[h]
					if itemID==herb then
						local _,itemLink = GetItemInfo(itemID)
						DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..itemLink.." "..L["skipped"])
						return
					end
				end
			end
			--search internal table for millable herb ids and mill them
			if itemID and not MillButton_Herbs.NotMillable then
				local _,_,_,_,_,_,itemType = GetItemInfo(itemID)
				if (MillButton_Herbs.Millable or itemType == item_herb) and count >= 5 then
					return b,s
				end
			end
		end
	end
end]]

local function findherb()
	local function f(b,s)
		if GetContainerItemLink(b,s) then
			local itemName,itemLink,_,_,_,_,itemType = GetItemInfo(GetContainerItemID(b,s))
			local itemID = GetContainerItemID(b,s)
			if extended_millbutton~=true then
				return
			else
			local db = MillButton_Herbs.NotMillable
				--search internal db for ignored herb ids and skip them
				for h=1,#db do
					local herb = db[h]
					if itemID==herb then
						DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..itemLink.." "..L["skipped"])
						return
					end
				end
			end
			return (itemType==item_herb or itemID==MillButton_Herbs.Millable) and select(2,GetContainerItemInfo(b,s))>=5
		end
	end
		for i=0,4 do
			for j=1,GetContainerNumSlots(i) do
				if f(i,j) then
					return i,j
				end
			end
		end
end  

function MillButtonSetup()
extended_millbutton = false
	local b,s = findherb()
		if (not b or not s) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
		-- do nothing if no herb, if looting or casting
			MillButton:SetAttribute("macrotext","")
			if not b then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
			end
		else
			MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..L["macro_spell"].."\n/"..L["macro_use"].." "..b.." "..s)
		end
end

function MillButtonSetup2()
extended_millbutton = true
	local b,s = findherb()
		if (not b or not s) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
		-- do nothing if no herb, if looting or casting
			MillButton:SetAttribute("macrotext","")
			if not b then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
			end
		else
			MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..L["macro_spell"].."\n/"..L["macro_use"].." "..b.." "..s)
		end
end

--[[tbd flow]]--
function MillButtonStack()
	mill_Restack("bags", true)
end